////////////////////////////////////////////////////////////////////////////////
// File    : Button.cpp
// Content : Button component
// History : 03-Dec-2001 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Button.h>

#include <sstream>


namespace hsm {

/* Button class implementation ************************************************/

	const Button *Button::cast = 0;

	Button::Button(const Id &id, bool b /* = false */) : impl::Component< >(id), button(b) {
		std::stringstream buttonId;
		buttonId << id;
		buttonId >> indice;
	}

	Button &Button::operator=(bool b) {
		if(b != button) {
			button = b;
			dispatch(Event(this, Event::CHANGE, button));
		}
		return *this;
	}


} // namespace hsm
