////////////////////////////////////////////////////////////////////////////////
// File    : Button.h
// Content : Button component
// History : 26-Nov-2001 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// ToDo ////////////////////////////////////////////////////////////////////////
// - add assignement operators


#if !defined(HSM_BUTTON_H)
#define HSM_BUTTON_H


/* includes *******************************************************************/

#include <hsm/core/Component.h>


namespace hsm {

/* Button class definition ****************************************************/

	class Button : public impl::Component< > {
	public :
		static const Button *cast;

	protected :
		bool button;
		int indice;

	public :
		Button(const Id &id, bool b = false);

		inline int getIndice() const { return indice; }

		inline operator const bool() const { return button; }

		Button &operator=(bool b);
	};


} // namespace hsm


#endif // !defined(HSM_BUTTON_H)