////////////////////////////////////////////////////////////////////////////////
// File    : SVGLCursor.h
// Content : Cursor class
// History : 28-Jan-2004 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#if !defined(HSM_SVGLCURSOR_H)
#define HSM_SVGLCURSOR_H


/* includes *******************************************************************/

#include <hsm/core/Component.h>
#include <hsm/core/Processing.h>
#include <hsm/component/Point.h>


/* forward declarations ******************************************************/

namespace svg {
	class SVGTranslateTransform;
	class SVGGElement;
}

	
namespace hsm {

	class SVGLWindow;
	

/* SVGLCursor class definition ************************************************/

	class SVGLCursor : impl::Component< Component, processing::MonoAsync > {
	protected :
		Point *position;
		SVGLWindow *window;
		Point windowPosition;
		svg::SVGTranslateTransform *trans;
		
		svg::SVGGElement *layer;
		svg::SVGGElement *cursor;
		
		float hotX, hotY;
		
	public :
		SVGLCursor(Point &p, SVGLWindow *w, const std::string &name, svg::SVGGElement *layer = 0, float offsetX = 0., float offsetY = 0.);
		virtual ~SVGLCursor();
		
		void setPosition(Point &p);

	protected :
		virtual void process(const Event &event);
	};
	
	
} // namespace hsm


#endif // !defined(HSM_SVGLCURSOR_H)
