////////////////////////////////////////////////////////////////////////////////
// File    : Alert.h
// Content : a class for selectable alert
// History : 13-Feb-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/// \file Alert.h
/// a class for a selectable alert


#if !defined(HSM_ALERT_H)
#define HSM_ALERT_H


/* includes *******************************************************************/

#include <hsm/system/select/Selectable.h>


namespace hsm {

/* Alert class declaration ****************************************************/

	/// implements a selectable alert
	class Alert : public Selectable {
	protected :
		file::Descriptor *alert;
		
	public :
		         Alert(); ///< constructor
		virtual ~Alert(); ///< destructor
		
		/// sets the alert
		/// If the alert is watched by a system \c select (or its equivalent on
		/// non unix platforms) or by a hsm::Selector, the select is waked-up when
		/// the alert is set.
		virtual void set();
		
		/// resets the alert
		virtual void reset();
	};


} // namespace hsm


#endif // !defined(HSM_ALERT_H)