////////////////////////////////////////////////////////////////////////////////
// File    : test-Chrono.cpp
// Content : a test for hsm Chrono
// History : 14-Apr-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2003  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <cstdlib>
#include <iostream>
using namespace std;

#include <hsm/system/time/Chrono.h>
#include <hsm/system/thread/Thread.h>


/* handle quit ****************************************************************/

void quitHandler() {
	cout << endl << "bye." << endl;
}


/* main ***********************************************************************/

int main(int argc, const char *argv[]) {
	cout << "test-Chrono - a program to test the hsm::Chrono class." << endl << endl;
	atexit(quitHandler);
	
	hsm::Chrono chrono;

	cout << "starting chronometer." << endl;
	chrono.start();
	
	cout << "sleeping 1s." << endl;
	hsm::thread::sleep(1000);
	
	cout << "elpased time is : " << chrono.stop() << endl;
	
	cout << "sleeping 1s." << endl;
	hsm::thread::sleep(1000);

	cout << "final time is : " << chrono.stop() << endl;
	
	return EXIT_SUCCESS;
}
